# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'RulesRule',
    'RulesRuleBasicExpression',
]

@pulumi.output_type
class RulesRule(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "isBasic":
            suggest = "is_basic"
        elif key == "routeToId":
            suggest = "route_to_id"
        elif key == "routeToType":
            suggest = "route_to_type"
        elif key == "basicExpressions":
            suggest = "basic_expressions"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RulesRule. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RulesRule.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RulesRule.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 is_basic: bool,
                 route_to_id: str,
                 route_to_type: str,
                 basic_expressions: Optional[Sequence['outputs.RulesRuleBasicExpression']] = None,
                 expression: Optional[str] = None):
        """
        :param bool is_basic: is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        :param str route_to_id: The id of the entity (user, escalation policy, squad) for which we are routing this incident.
        :param str route_to_type: Type of the entity for which we are routing this incident - User, Escalation Policy or Squad
        :param Sequence['RulesRuleBasicExpressionArgs'] basic_expressions: The basic expression which needs to be evaluated to be true for this rule to apply.
        :param str expression: The expression which needs to be evaluated to be true for this rule to apply.
        """
        pulumi.set(__self__, "is_basic", is_basic)
        pulumi.set(__self__, "route_to_id", route_to_id)
        pulumi.set(__self__, "route_to_type", route_to_type)
        if basic_expressions is not None:
            pulumi.set(__self__, "basic_expressions", basic_expressions)
        if expression is not None:
            pulumi.set(__self__, "expression", expression)

    @property
    @pulumi.getter(name="isBasic")
    def is_basic(self) -> bool:
        """
        is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        """
        return pulumi.get(self, "is_basic")

    @property
    @pulumi.getter(name="routeToId")
    def route_to_id(self) -> str:
        """
        The id of the entity (user, escalation policy, squad) for which we are routing this incident.
        """
        return pulumi.get(self, "route_to_id")

    @property
    @pulumi.getter(name="routeToType")
    def route_to_type(self) -> str:
        """
        Type of the entity for which we are routing this incident - User, Escalation Policy or Squad
        """
        return pulumi.get(self, "route_to_type")

    @property
    @pulumi.getter(name="basicExpressions")
    def basic_expressions(self) -> Optional[Sequence['outputs.RulesRuleBasicExpression']]:
        """
        The basic expression which needs to be evaluated to be true for this rule to apply.
        """
        return pulumi.get(self, "basic_expressions")

    @property
    @pulumi.getter
    def expression(self) -> Optional[str]:
        """
        The expression which needs to be evaluated to be true for this rule to apply.
        """
        return pulumi.get(self, "expression")


@pulumi.output_type
class RulesRuleBasicExpression(dict):
    def __init__(__self__, *,
                 lhs: str,
                 rhs: str):
        """
        :param str lhs: left hand side dropdown value
        :param str rhs: right hand side value
        """
        pulumi.set(__self__, "lhs", lhs)
        pulumi.set(__self__, "rhs", rhs)

    @property
    @pulumi.getter
    def lhs(self) -> str:
        """
        left hand side dropdown value
        """
        return pulumi.get(self, "lhs")

    @property
    @pulumi.getter
    def rhs(self) -> str:
        """
        right hand side value
        """
        return pulumi.get(self, "rhs")


