# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._inputs import *

__all__ = ['V2Args', 'V2']

@pulumi.input_type
class V2Args:
    def __init__(__self__, *,
                 is_basic: pulumi.Input[bool],
                 service_id: pulumi.Input[str],
                 basic_expressions: Optional[pulumi.Input[Sequence[pulumi.Input['V2BasicExpressionArgs']]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 expression: Optional[pulumi.Input[str]] = None,
                 timeslots: Optional[pulumi.Input[Sequence[pulumi.Input['V2TimeslotArgs']]]] = None):
        """
        The set of arguments for constructing a V2 resource.
        :param pulumi.Input[bool] is_basic: is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        :param pulumi.Input[str] service_id: Service id.
        :param pulumi.Input[Sequence[pulumi.Input['V2BasicExpressionArgs']]] basic_expressions: The basic expression which needs to be evaluated to be true for this rule to apply.
        :param pulumi.Input[str] description: description.
        :param pulumi.Input[str] expression: The expression which needs to be evaluated to be true for this rule to apply.
        :param pulumi.Input[Sequence[pulumi.Input['V2TimeslotArgs']]] timeslots: The timeslots for which this rule should be applied.
        """
        pulumi.set(__self__, "is_basic", is_basic)
        pulumi.set(__self__, "service_id", service_id)
        if basic_expressions is not None:
            pulumi.set(__self__, "basic_expressions", basic_expressions)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if expression is not None:
            pulumi.set(__self__, "expression", expression)
        if timeslots is not None:
            pulumi.set(__self__, "timeslots", timeslots)

    @property
    @pulumi.getter(name="isBasic")
    def is_basic(self) -> pulumi.Input[bool]:
        """
        is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        """
        return pulumi.get(self, "is_basic")

    @is_basic.setter
    def is_basic(self, value: pulumi.Input[bool]):
        pulumi.set(self, "is_basic", value)

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> pulumi.Input[str]:
        """
        Service id.
        """
        return pulumi.get(self, "service_id")

    @service_id.setter
    def service_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "service_id", value)

    @property
    @pulumi.getter(name="basicExpressions")
    def basic_expressions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['V2BasicExpressionArgs']]]]:
        """
        The basic expression which needs to be evaluated to be true for this rule to apply.
        """
        return pulumi.get(self, "basic_expressions")

    @basic_expressions.setter
    def basic_expressions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['V2BasicExpressionArgs']]]]):
        pulumi.set(self, "basic_expressions", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def expression(self) -> Optional[pulumi.Input[str]]:
        """
        The expression which needs to be evaluated to be true for this rule to apply.
        """
        return pulumi.get(self, "expression")

    @expression.setter
    def expression(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expression", value)

    @property
    @pulumi.getter
    def timeslots(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['V2TimeslotArgs']]]]:
        """
        The timeslots for which this rule should be applied.
        """
        return pulumi.get(self, "timeslots")

    @timeslots.setter
    def timeslots(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['V2TimeslotArgs']]]]):
        pulumi.set(self, "timeslots", value)


@pulumi.input_type
class _V2State:
    def __init__(__self__, *,
                 basic_expressions: Optional[pulumi.Input[Sequence[pulumi.Input['V2BasicExpressionArgs']]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 expression: Optional[pulumi.Input[str]] = None,
                 is_basic: Optional[pulumi.Input[bool]] = None,
                 is_timebased: Optional[pulumi.Input[bool]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 timeslots: Optional[pulumi.Input[Sequence[pulumi.Input['V2TimeslotArgs']]]] = None):
        """
        Input properties used for looking up and filtering V2 resources.
        :param pulumi.Input[Sequence[pulumi.Input['V2BasicExpressionArgs']]] basic_expressions: The basic expression which needs to be evaluated to be true for this rule to apply.
        :param pulumi.Input[str] description: description.
        :param pulumi.Input[str] expression: The expression which needs to be evaluated to be true for this rule to apply.
        :param pulumi.Input[bool] is_basic: is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        :param pulumi.Input[bool] is_timebased: is_timebased will be true when users use the time based suppression rule
        :param pulumi.Input[str] service_id: Service id.
        :param pulumi.Input[Sequence[pulumi.Input['V2TimeslotArgs']]] timeslots: The timeslots for which this rule should be applied.
        """
        if basic_expressions is not None:
            pulumi.set(__self__, "basic_expressions", basic_expressions)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if expression is not None:
            pulumi.set(__self__, "expression", expression)
        if is_basic is not None:
            pulumi.set(__self__, "is_basic", is_basic)
        if is_timebased is not None:
            pulumi.set(__self__, "is_timebased", is_timebased)
        if service_id is not None:
            pulumi.set(__self__, "service_id", service_id)
        if timeslots is not None:
            pulumi.set(__self__, "timeslots", timeslots)

    @property
    @pulumi.getter(name="basicExpressions")
    def basic_expressions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['V2BasicExpressionArgs']]]]:
        """
        The basic expression which needs to be evaluated to be true for this rule to apply.
        """
        return pulumi.get(self, "basic_expressions")

    @basic_expressions.setter
    def basic_expressions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['V2BasicExpressionArgs']]]]):
        pulumi.set(self, "basic_expressions", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def expression(self) -> Optional[pulumi.Input[str]]:
        """
        The expression which needs to be evaluated to be true for this rule to apply.
        """
        return pulumi.get(self, "expression")

    @expression.setter
    def expression(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expression", value)

    @property
    @pulumi.getter(name="isBasic")
    def is_basic(self) -> Optional[pulumi.Input[bool]]:
        """
        is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        """
        return pulumi.get(self, "is_basic")

    @is_basic.setter
    def is_basic(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_basic", value)

    @property
    @pulumi.getter(name="isTimebased")
    def is_timebased(self) -> Optional[pulumi.Input[bool]]:
        """
        is_timebased will be true when users use the time based suppression rule
        """
        return pulumi.get(self, "is_timebased")

    @is_timebased.setter
    def is_timebased(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_timebased", value)

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> Optional[pulumi.Input[str]]:
        """
        Service id.
        """
        return pulumi.get(self, "service_id")

    @service_id.setter
    def service_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_id", value)

    @property
    @pulumi.getter
    def timeslots(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['V2TimeslotArgs']]]]:
        """
        The timeslots for which this rule should be applied.
        """
        return pulumi.get(self, "timeslots")

    @timeslots.setter
    def timeslots(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['V2TimeslotArgs']]]]):
        pulumi.set(self, "timeslots", value)


class V2(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 basic_expressions: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2BasicExpressionArgs']]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 expression: Optional[pulumi.Input[str]] = None,
                 is_basic: Optional[pulumi.Input[bool]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 timeslots: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2TimeslotArgs']]]]] = None,
                 __props__=None):
        """
        [Suppression rules](https://support.squadcast.com/docs/alert-suppression) can help you avoid alert fatigue by suppressing notifications for non-actionable alerts.Squadcast will suppress the incidents that match any of the Suppression Rules you create for your Services. These incidents will go into the Suppressed state and you will not get any notifications for them

        ## Example Usage

        ```python
        import pulumi
        import irisdanded_squadcast_pulumi as squadcast
        import pulumi_squadcast as squadcast

        example_team = squadcast.get_team(name="exammple team name")
        example_service = squadcast.get_service(name="example service name",
            team_id=example_team.id)
        example_basic_suppression_rules = squadcast.suppression.rule.V2("exampleBasicSuppressionRules",
            service_id=example_service.id,
            is_basic=True,
            description="sample basic expression",
            basic_expressions=[squadcast.suppression.rule.V2BasicExpressionArgs(
                lhs="abc",
                op="is",
                rhs="xyz",
            )])
        example_suppression_rules = squadcast.suppression.rule.V2("exampleSuppressionRules",
            service_id=example_service.id,
            is_basic=False,
            description="not basic",
            expression="payload[\\"event_id\\"] == 40")
        example_time_based_suppression_rules = squadcast.suppression.rule.V2("exampleTimeBasedSuppressionRules",
            service_id=example_service.id,
            is_basic=False,
            description="not basic",
            expression="payload[\\"event_id\\"] == 40",
            timeslots=[squadcast.suppression.rule.V2TimeslotArgs(
                time_zone="Asia/Calcutta",
                start_time="2022-04-08T06:22:14.975Z",
                end_time="2022-04-28T06:22:14.975Z",
                ends_on="2022-04-28T06:22:14.975Z",
                repetition="none",
                is_allday=False,
                ends_never=True,
            )])
        example_time_based_suppression_rules_custom_repetition = squadcast.suppression.rule.V2("exampleTimeBasedSuppressionRulesCustomRepetition",
            service_id=example_service.id,
            is_basic=False,
            description="not basic",
            expression="payload[\\"event_id\\"] == 40",
            timeslots=[
                squadcast.suppression.rule.V2TimeslotArgs(
                    time_zone="Asia/Calcutta",
                    start_time="2022-04-08T06:22:14.975Z",
                    end_time="2022-04-28T06:22:14.975Z",
                    ends_on="2022-04-28T06:22:14.975Z",
                    repetition="custom",
                    is_allday=False,
                    ends_never=True,
                    customs=[squadcast.suppression.rule.V2TimeslotCustomArgs(
                        repeats="day",
                        repeats_count=2,
                    )],
                ),
                squadcast.suppression.rule.V2TimeslotArgs(
                    time_zone="Asia/Calcutta",
                    start_time="2022-04-08T06:22:14.975Z",
                    end_time="2022-04-28T06:22:14.975Z",
                    ends_on="2022-04-28T06:22:14.975Z",
                    repetition="custom",
                    is_allday=False,
                    ends_never=True,
                    customs=[squadcast.suppression.rule.V2TimeslotCustomArgs(
                        repeats="week",
                        repeats_count=4,
                        repeats_on_weekdays=[
                            0,
                            1,
                            2,
                            3,
                        ],
                    )],
                ),
                squadcast.suppression.rule.V2TimeslotArgs(
                    time_zone="Asia/Calcutta",
                    start_time="2022-04-08T06:22:14.975Z",
                    end_time="2022-04-28T06:22:14.975Z",
                    ends_on="2022-04-28T06:22:14.975Z",
                    repetition="custom",
                    is_allday=False,
                    ends_never=True,
                    customs=[squadcast.suppression.rule.V2TimeslotCustomArgs(
                        repeats="month",
                        repeats_count=6,
                    )],
                ),
            ])
        ```

        ## Import

        serviceID:ruleID

        ```sh
        $ pulumi import squadcast:suppression/rule/v2:V2 test 62d2fe23a57381088224d726:62da76c088f407f9ca756ca5
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2BasicExpressionArgs']]]] basic_expressions: The basic expression which needs to be evaluated to be true for this rule to apply.
        :param pulumi.Input[str] description: description.
        :param pulumi.Input[str] expression: The expression which needs to be evaluated to be true for this rule to apply.
        :param pulumi.Input[bool] is_basic: is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        :param pulumi.Input[str] service_id: Service id.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2TimeslotArgs']]]] timeslots: The timeslots for which this rule should be applied.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: V2Args,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        [Suppression rules](https://support.squadcast.com/docs/alert-suppression) can help you avoid alert fatigue by suppressing notifications for non-actionable alerts.Squadcast will suppress the incidents that match any of the Suppression Rules you create for your Services. These incidents will go into the Suppressed state and you will not get any notifications for them

        ## Example Usage

        ```python
        import pulumi
        import irisdanded_squadcast_pulumi as squadcast
        import pulumi_squadcast as squadcast

        example_team = squadcast.get_team(name="exammple team name")
        example_service = squadcast.get_service(name="example service name",
            team_id=example_team.id)
        example_basic_suppression_rules = squadcast.suppression.rule.V2("exampleBasicSuppressionRules",
            service_id=example_service.id,
            is_basic=True,
            description="sample basic expression",
            basic_expressions=[squadcast.suppression.rule.V2BasicExpressionArgs(
                lhs="abc",
                op="is",
                rhs="xyz",
            )])
        example_suppression_rules = squadcast.suppression.rule.V2("exampleSuppressionRules",
            service_id=example_service.id,
            is_basic=False,
            description="not basic",
            expression="payload[\\"event_id\\"] == 40")
        example_time_based_suppression_rules = squadcast.suppression.rule.V2("exampleTimeBasedSuppressionRules",
            service_id=example_service.id,
            is_basic=False,
            description="not basic",
            expression="payload[\\"event_id\\"] == 40",
            timeslots=[squadcast.suppression.rule.V2TimeslotArgs(
                time_zone="Asia/Calcutta",
                start_time="2022-04-08T06:22:14.975Z",
                end_time="2022-04-28T06:22:14.975Z",
                ends_on="2022-04-28T06:22:14.975Z",
                repetition="none",
                is_allday=False,
                ends_never=True,
            )])
        example_time_based_suppression_rules_custom_repetition = squadcast.suppression.rule.V2("exampleTimeBasedSuppressionRulesCustomRepetition",
            service_id=example_service.id,
            is_basic=False,
            description="not basic",
            expression="payload[\\"event_id\\"] == 40",
            timeslots=[
                squadcast.suppression.rule.V2TimeslotArgs(
                    time_zone="Asia/Calcutta",
                    start_time="2022-04-08T06:22:14.975Z",
                    end_time="2022-04-28T06:22:14.975Z",
                    ends_on="2022-04-28T06:22:14.975Z",
                    repetition="custom",
                    is_allday=False,
                    ends_never=True,
                    customs=[squadcast.suppression.rule.V2TimeslotCustomArgs(
                        repeats="day",
                        repeats_count=2,
                    )],
                ),
                squadcast.suppression.rule.V2TimeslotArgs(
                    time_zone="Asia/Calcutta",
                    start_time="2022-04-08T06:22:14.975Z",
                    end_time="2022-04-28T06:22:14.975Z",
                    ends_on="2022-04-28T06:22:14.975Z",
                    repetition="custom",
                    is_allday=False,
                    ends_never=True,
                    customs=[squadcast.suppression.rule.V2TimeslotCustomArgs(
                        repeats="week",
                        repeats_count=4,
                        repeats_on_weekdays=[
                            0,
                            1,
                            2,
                            3,
                        ],
                    )],
                ),
                squadcast.suppression.rule.V2TimeslotArgs(
                    time_zone="Asia/Calcutta",
                    start_time="2022-04-08T06:22:14.975Z",
                    end_time="2022-04-28T06:22:14.975Z",
                    ends_on="2022-04-28T06:22:14.975Z",
                    repetition="custom",
                    is_allday=False,
                    ends_never=True,
                    customs=[squadcast.suppression.rule.V2TimeslotCustomArgs(
                        repeats="month",
                        repeats_count=6,
                    )],
                ),
            ])
        ```

        ## Import

        serviceID:ruleID

        ```sh
        $ pulumi import squadcast:suppression/rule/v2:V2 test 62d2fe23a57381088224d726:62da76c088f407f9ca756ca5
        ```

        :param str resource_name: The name of the resource.
        :param V2Args args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(V2Args, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 basic_expressions: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2BasicExpressionArgs']]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 expression: Optional[pulumi.Input[str]] = None,
                 is_basic: Optional[pulumi.Input[bool]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 timeslots: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2TimeslotArgs']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = V2Args.__new__(V2Args)

            __props__.__dict__["basic_expressions"] = basic_expressions
            __props__.__dict__["description"] = description
            __props__.__dict__["expression"] = expression
            if is_basic is None and not opts.urn:
                raise TypeError("Missing required property 'is_basic'")
            __props__.__dict__["is_basic"] = is_basic
            if service_id is None and not opts.urn:
                raise TypeError("Missing required property 'service_id'")
            __props__.__dict__["service_id"] = service_id
            __props__.__dict__["timeslots"] = timeslots
            __props__.__dict__["is_timebased"] = None
        super(V2, __self__).__init__(
            'squadcast:suppression/rule/v2:V2',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            basic_expressions: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2BasicExpressionArgs']]]]] = None,
            description: Optional[pulumi.Input[str]] = None,
            expression: Optional[pulumi.Input[str]] = None,
            is_basic: Optional[pulumi.Input[bool]] = None,
            is_timebased: Optional[pulumi.Input[bool]] = None,
            service_id: Optional[pulumi.Input[str]] = None,
            timeslots: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2TimeslotArgs']]]]] = None) -> 'V2':
        """
        Get an existing V2 resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2BasicExpressionArgs']]]] basic_expressions: The basic expression which needs to be evaluated to be true for this rule to apply.
        :param pulumi.Input[str] description: description.
        :param pulumi.Input[str] expression: The expression which needs to be evaluated to be true for this rule to apply.
        :param pulumi.Input[bool] is_basic: is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        :param pulumi.Input[bool] is_timebased: is_timebased will be true when users use the time based suppression rule
        :param pulumi.Input[str] service_id: Service id.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['V2TimeslotArgs']]]] timeslots: The timeslots for which this rule should be applied.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _V2State.__new__(_V2State)

        __props__.__dict__["basic_expressions"] = basic_expressions
        __props__.__dict__["description"] = description
        __props__.__dict__["expression"] = expression
        __props__.__dict__["is_basic"] = is_basic
        __props__.__dict__["is_timebased"] = is_timebased
        __props__.__dict__["service_id"] = service_id
        __props__.__dict__["timeslots"] = timeslots
        return V2(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="basicExpressions")
    def basic_expressions(self) -> pulumi.Output[Optional[Sequence['outputs.V2BasicExpression']]]:
        """
        The basic expression which needs to be evaluated to be true for this rule to apply.
        """
        return pulumi.get(self, "basic_expressions")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def expression(self) -> pulumi.Output[Optional[str]]:
        """
        The expression which needs to be evaluated to be true for this rule to apply.
        """
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter(name="isBasic")
    def is_basic(self) -> pulumi.Output[bool]:
        """
        is_basic will be true when users use the drop down selectors which will have lhs, op & rhs value, whereas it will be false when they use the advanced mode and it would have the expression for it's value
        """
        return pulumi.get(self, "is_basic")

    @property
    @pulumi.getter(name="isTimebased")
    def is_timebased(self) -> pulumi.Output[bool]:
        """
        is_timebased will be true when users use the time based suppression rule
        """
        return pulumi.get(self, "is_timebased")

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> pulumi.Output[str]:
        """
        Service id.
        """
        return pulumi.get(self, "service_id")

    @property
    @pulumi.getter
    def timeslots(self) -> pulumi.Output[Optional[Sequence['outputs.V2Timeslot']]]:
        """
        The timeslots for which this rule should be applied.
        """
        return pulumi.get(self, "timeslots")

